#
#	makefile for GSM Half-Rate Speech Codec
#	Version 5.0.0
#	November 8, 1996
#
.SUFFIXES: .out .obj .c .e .r .f .y .l .s .p .os
CC=TCC
CDIR=..\c
UTILSDIR=..\utils

TCDIR=c:\turboc\lib
CAlsoDef=-A -I$(CDIR) -Fc -ml
CDefault=$(CAlsoDef)
CDefaultExec=$(CAlsoDef)

# installation
install: gsm_hr reid swapbin tosnwild topcwild

# EXACT files
globdefs.obj:  $(CDIR)\globdefs.c
	$(CC) $(CDefault) -c $?
mathdp31.obj:  $(CDIR)\mathdp31.c
	$(CC) $(CDefault) -c $?
mathhalf.obj:  $(CDIR)\mathhalf.c
	$(CC) $(CDefault) -c $?

# 
# speech coder: analysis and synthesis
#  object files
#
dtx.obj:  $(CDIR)\dtx.c
	$(CC) $(CDefault) -c $?
err_conc.obj:  $(CDIR)\err_conc.c
	$(CC) $(CDefault) -c $?
homing.obj:  $(CDIR)\homing.c
	$(CC) $(CDefault) -c $?
sp_dec.obj:  $(CDIR)\sp_dec.c
	$(CC) $(CDefault) -c $?
sp_enc.obj:  $(CDIR)\sp_enc.c
	$(CC) $(CDefault) -c $?
sp_rom.obj:  $(CDIR)\sp_rom.c
	$(CC) $(CDefault) -c $?
sp_sfrm.obj:  $(CDIR)\sp_sfrm.c
	$(CC) $(CDefault) -c $?
sp_frm.obj:  $(CDIR)\sp_frm.c
	$(CC) $(CDefault) -c $?
vad.obj:  $(CDIR)\vad.c
	$(CC) $(CDefault) -c $?

# Host files
host.obj:  $(CDIR)\host.c
	$(CC) $(CDefault) -c $?

# main program
gsm_hr.obj: $(CDIR)\gsm_hr.c
	$(CC) $(CDefault) -c $?

# utility programs
reid.obj:  $(UTILSDIR)\reid.c
	$(CC) $(CDefault) -c $?
swapbin.obj:  $(UTILSDIR)\swapbin.c
	$(CC) $(CDefault) -c $?
topcwild.obj:  $(UTILSDIR)\topcwild.c
	$(CC) $(CDefault) -c $?
tosnwild.obj:  $(UTILSDIR)\tosnwild.c
	$(CC) $(CDefault) -c $?

# ***********************  symbols ******************************************

EXACT3 = globdefs.obj mathdp31.obj mathhalf.obj 

SPEECH = sp_dec.obj sp_enc.obj sp_frm.obj sp_rom.obj sp_sfrm.obj

GSM_HR = $(EXACT3) $(SPEECH) dtx.obj err_conc.obj host.obj homing.obj vad.obj


#***********************  executables  **************************************

# main program
gsm_hr: gsm_hr.obj $(GSM_HR)  
	$(CC) $(CDefaultExec) -egsm_hr.exe @gsm_hr.rsp 

# utility programs
reid: reid.obj
	$(CC) $(CDefaultExec) -ereid.exe  reid.obj
swapbin: swapbin.obj
	$(CC) $(CDefaultExec) -eswapbin.exe  swapbin.obj
tosnwild: tosnwild.obj
	$(CC) $(CDefaultExec) -etosnwild.exe  tosnwild.obj
topcwild: topcwild.obj
	$(CC) $(CDefaultExec) -etopcwild.exe  topcwild.obj
